<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>Sto</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="stos"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <StoForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import StoForm from "../components/StoForm";
import service from "../service/StoService";

export default {
  name: "Sto",
  components: {
    StoForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      stos: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "REGIONAL", align: "center", value: "witel.regional.nama", sortable: true },
        { text: "WITEL", align: "center", value: "witel.nama", sortable: true },
        { text: "ALIAS", align: "center", value: "alias", sortable: true },
        { text: "NAMA", align: "center", value: "nama", sortable: true },
        { text: "CREATE DATE", align: "center", value: "create_at", sortable: true },
        { text: "UPDATE DATE", align: "center", value: "update_at", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New STO"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data STO ${data.id} - ${data.nama}`)) {
        return false
      }
      this.statusProgress = true
      await service.delete(data.id).then(async res => {
        let {status, message} = res.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        console.log(ex)
        this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
      })
      this.statusProgress = false
    },
    doEdit(id) {
      let title = "Edit STO"
      this.$refs.dlg.doEdit(id, title, true)
    },
    async doRefresh() {
      this.statusProgress = true
      await service.getAll()
        .then(res => {
          this.stos = res.data.data
        })
      this.statusProgress = false
    }
  },
  mounted() {
    this.doRefresh()
  }
}
</script>

<style scoped>

</style>